package x64

// Jump continues program flow at the new address.
// The address is relative to the next instruction.
func Jump8(code []byte, address int8) []byte {
	return jump8(code, 0xEB, address)
}

// JumpIfLess jumps if the result was less.
func Jump8IfLess(code []byte, address int8) []byte {
	return jump8(code, 0x7C, address)
}

// JumpIfLessOrEqual jumps if the result was less or equal.
func Jump8IfLessOrEqual(code []byte, address int8) []byte {
	return jump8(code, 0x7E, address)
}

// JumpIfGreater jumps if the result was greater.
func Jump8IfGreater(code []byte, address int8) []byte {
	return jump8(code, 0x7F, address)
}

// JumpIfGreaterOrEqual jumps if the result was greater or equal.
func Jump8IfGreaterOrEqual(code []byte, address int8) []byte {
	return jump8(code, 0x7D, address)
}

// JumpIfEqual jumps if the result was equal.
func Jump8IfEqual(code []byte, address int8) []byte {
	return jump8(code, 0x74, address)
}

// JumpIfNotEqual jumps if the result was not equal.
func Jump8IfNotEqual(code []byte, address int8) []byte {
	return jump8(code, 0x75, address)
}

func jump8(code []byte, opCode byte, address int8) []byte {
	return append(
		code,
		opCode,
		byte(address),
	)
}
