package core

import (
	"fmt"

	"git.akyoto.dev/cli/q/src/build/asm"
	"git.akyoto.dev/cli/q/src/build/ast"
)

// CompileIf compiles a branch instruction.
func (f *Function) CompileIf(branch *ast.If) error {
	err := f.Evaluate(branch.Condition)

	if err != nil {
		return err
	}

	endLabel := fmt.Sprintf("%s_end_if_%d", f.Name, f.count.branch)

	switch branch.Condition.Token.Text() {
	case "==":
		f.assembler.Label(asm.JNE, endLabel)
	case "!=":
		f.assembler.Label(asm.JE, endLabel)
	case ">":
		f.assembler.Label(asm.JLE, endLabel)
	case "<":
		f.assembler.Label(asm.JGE, endLabel)
	case ">=":
		f.assembler.Label(asm.JL, endLabel)
	case "<=":
		f.assembler.Label(asm.JG, endLabel)
	}

	defer f.assembler.Label(asm.LABEL, endLabel)
	f.count.branch++
	return f.CompileAST(branch.Body)
}
